#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <time.h>
#include <pd/thing.h>

extern char *_sys_var;

typedef struct
{
    char path[40];
    time_t stamp;
}
FAXITEM;

typedef struct
{
    int flag;
    int type;
    short maxitems;
    short current;
    short nitems;
    FAXITEM fdata[1];
}
FAX_LIST;

/*
 * Let's just have one of these
 */

static char *Stuff = "QFAX Items";

#define STUFF_SIZE 10

/*
 * Here we define our simple thing
 */

char *qtrim (char *ep)
{
    char *p;
    short i;
    
    p = ep + strlen(ep);
    for(i = 0; i < 3 && --p > ep;)
    {
        if(*(p-1) == '_')
        {
            i++;
        }
    }
    return p;
}

int main (void)
{
    PTHG_LINK p = NULL;
    int vers = 0;
    void *q;
    int sts;
    int jid;

    /*
     * See if we can use the thing
     */

    sts = sms_uthg (Stuff, -1, -1, NULL, &p, &vers, &q);

    if (sts == 0)
    {
	short i, j;

        
	j = ((FAX_LIST *) p->thing)->current;
	if (((FAX_LIST *) p->thing)->nitems)
	{
	    for (i = 0; i < ((FAX_LIST *) p->thing)->nitems; i++)
	    {
		char *s, txt[32];

		if (j == 0)
		{
		    j = ((FAX_LIST *) p->thing)->maxitems - 1;
		}
		else
		{
		    j--;
		}
		s = cn_date (txt, ((FAX_LIST *) p->thing)->fdata[j].stamp);
		printf ("%2d: %-40.40s ", j,
                        qtrim(((FAX_LIST *) p->thing)->fdata[j].path));
		puts (s);
	    }
	}
	else
	{
	    puts ("Fax list is Empty");
	}
	sts = sms_fthg (Stuff, -1, 0, NULL, NULL, NULL);
    }

    return 0;
}
