#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <qdos.h>
#include <qptr.h>
#include "qfv.h"

static long MMOVE (struct WM_wwork *);
static struct WM_action mmove = {JSR, wm_actli, MMOVE};
static long ACHOICE (struct WM_wwork *, struct WM_litm *, struct WM_wstat *);
static struct WM_action achoice = {JSR, wm_actli, ACHOICE};

extern struct WM_sprite mes_move;
extern jcall (void (*)(), char *, int, int, int,...);
static QD_TEXTI (PRINTIN, "Printing");
static QD_TEXTI (ABO, "Abort");
static QD_TEXTI (REM, "Remove");
static QD_TEXTI (CAN, "Cancel");
static QD_TEXT(40) fname = {0};
static struct WM_wstat ws = {0};
static struct WM_info info1[2] =
{
    {48, 10, 32, 0, 0, 0, 0,0,0, &PRINTIN},
    {-1}
};
static struct WM_info info2[2] =
{
    {240,10,  0, 0, 0, 0, 0,0,0, &fname},
    {-1}
};
static struct WM_litm litm[3 + 1] =
{
    {22, 10,  2,  1, 0, 0,  2, K_MOVE,     &mes_move, 0, &mmove},
    {48, 10, 18, 15, 0, 0,  -1, 'C',       &CAN,      1, &achoice},
    {48, 10,194, 15, 0, 0,  -1, 'R',       &REM,      2, &achoice},
    {-1}
};
static struct WM_infw infw[6] =		/* information window */
{
    {84, 12,			/* xsize, ysize         size */
     88, 0,		        /* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 1, 7,			/* borw, borc, papr border width/clr,paper */
     info1},   			/* *pobj  pointer to object list */
    {260, 16,			/* xsize, ysize size */
     0, 12,		        /* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 1, 7,			/* borw, borc, papr border width/clr,paper */
     NULL},   			/* *pobj  pointer to object list */
    {52, 12,  16, 14, 0, 1, 4, 7, NULL},
    {52, 12, 192, 14, 0, 1, 4, 7, NULL},
    {240,10,  10, 30, 0, 0, 0, 7, info2},
    {-1}
};
static struct WM_wwork ww =	/* window working definition */
{
    NULL,			/* *wstat;        pointer to status area */
    NULL,			/* *wscale        this was pointer to WDEF */
    0,			/* chid              channel ID */
    NULL,			/* *pprec     pointer to pointer record */
    0,			/* psave              pointer position saved */
    0, 0, 0, 0,		/* 4 zero */
    NULL,			/* *splst          pointer to sprite list */
    260, 40,  		/* xsize, ysize */
    0, 0,			/* xorg, yorg           and origin */
    2,      		/* flag                 no clear + shadow */
    1, 4, 7,		/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 0,   		/* curw, curc         current item width/clr */
    CL_MPUNAV, CL_MIUNAV, NULL, NULL,	/*uback, uink, *ublob, *upatt unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt avail */
    CL_MPSLCT, CL_MISLCT, NULL, NULL,  /*sback, sink, *sblob, *spatt selected */
    NULL,			/* *help */
    5, 2, infw,		/* ninfo, ninob, *pinfo info winds */
    2, litm,		/* nlitm, *plitm        loose items */
    0, NULL			/* nappl  *pappl        appl winds */
};

static void waitmouse(WM_wwork_t *wwk)
{
    while (!wm_rptr (wwk))
    {
        if (wwk->wstat->evnt & PT_CAN)
    	break;
    }
    pv->preq = NULL;
    wm_cluns (&ww);	
}

int PrintAbort (void)
{
    int pid = -1;

    strcpy((char *) fname.chrs, pv->FileName);
    fname.len = strlen(pv->FileName);
    info2[0].xorg = (240 - fname.len*6)/2;
    
    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;
    ws.wmode = FORM_QL4;

    ws.citem = -1;		/* no current item  */
    ws.ciact = NULL;		/* or current item routine */
    ws.litem[0] = WSI_MKAV;	/* preset ESC return */

    ww.xorg = 80;
    ww.yorg = 16;

    wm_pulld (&ww, -1, -1);
    wm_wdraw (&ww);
    pid = jcall (waitmouse, "PrintAbort", 1, 1024, 1, &ww);  
    return pid;
}

static long ACHOICE (struct WM_wwork *wwk, struct WM_litm *li, struct WM_wstat *wst)
{
    if(li->item == 1)
    {
        pv->pabort = 1;
    }

    lit_reset (wwk, li->item);
    return PT__CAN;		/* and return CAN event */
}
static long MMOVE (struct WM_wwork *wwk)
{
    short dx, dy;

    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */
    return lit_reset (wwk, 0);	/* and return */
}

char *SetRequester(void *p, void *q)
{
    int pid;
    pid = PrintAbort();
    if(pid > 0)
    {
        pv->preq = (char*)pid;
    }
    else
    {
        pv->preq = NULL;
    }
    return pv->preq;
}
int CheckPrAbort(void *p)
{
}


void ClearRequester(void *p)
{
	int temp;
    if(temp = (int) pv->preq)
    {
        pv->preq = NULL;
        mt_frjob(temp, 0);
	wm_cluns (&ww);	
    }
}
