#include <stdio.h>
#include <time.h>

#define TIMDIF 283996800

typedef struct
{
    char path[40];
    time_t stamp;
} FAXITEM;

typedef struct
{
    int flag;
    int type;
    short maxitems;
    short current;
    short nitems;
} FAX_LIST;

int main(void)
{
    FILE *fp;
    FAX_LIST fl;
    FAXITEM fx;
    time_t t;
    
    fp = fopen("arrivals_qfx", "w");
    fl.flag = 'THG%';
    fl.type =2;
        
    fl.maxitems = 24;
    fl.current = 8;
    fl.nitems = 8;

    fwrite(&fl, 1, sizeof(fl), fp);
    t = time(NULL) + TIMDIF - 3600;
    
    for(short i = 0; i < 8; i++)
    {
        fx.stamp = t + i * 2;
        if(i & 1)
        {
            strcpy (fx.path, "flp2_infax_gg_");
        }
        else
        {
            strcpy (fx.path, "win1_inbound_jrh_");
	}
	sprintf(fx.path+strlen(fx.path), "%05d_fax", i);
	fwrite(&fx, 1, sizeof(fx), fp);
    }
    fclose(fp);
}
