#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <qdos.h>
#include "qfv.h"

int SpawnCmd (char *, char *);
/*
 * SJOB structure defines parameters for spawned job.
 */

typedef struct
{
    char *FileName;
    char *ComStr;
    char *InFile;
    int inflag;
    char *OuFile;
    int ouid;
    int JobId;
    int serr;
    unsigned char Prio;
    unsigned char Wait;
} SJOB, *PSJOB;

extern int spawn(SJOB *);

static char * FullName(char *name, char *myname)
{
    char *p;
    int fnd;
    
    if(isdirdev (name) == 0)
    {
        if(getcpd(myname, 32))
        {
            p = strcat(myname, name);
        }
        if(access(p, 1) != 0)
        {
            if(getcwd(myname, 32))
            {
                p = strcat(myname, name);
            }
            else
            {
                p = name;
            }
        }
    }
    else
    {
        p = name;
    }
    return p;
}

int preview (char *cmd, char *opts)
{
    extern spawn(SJOB *);
    char ExeName[64];
    SJOB s;
    int res;
    
    memset (&s, '\0', sizeof (SJOB));
    s.FileName = FullName(stpblk(cmd), ExeName);
    s.InFile = NULL;
    s.inflag = -1;
    s.ComStr = *opts ? opts : NULL;
    s.OuFile = NULL;
    s.ouid = -1;
    s.serr = -1;
    s.Wait = 0;
    s.Prio = 4;
    s.JobId = 0;
    
    res = spawn(&s);
    return res;
    
}

