#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

typedef unsigned char UCHAR;

typedef struct
{
    char flag[8];
    UCHAR xpix;
    UCHAR ypix;
    UCHAR first;
    UCHAR last;
    UCHAR top_l;
    UCHAR bot_l;
    UCHAR right;
    UCHAR mode;
    long  fsize;
    UCHAR font[4];
} QFONT;

typedef struct
{
    char flag[8];
    UCHAR xpix[2];
    UCHAR ypix[2];
    UCHAR top_l;
    UCHAR bot_l;
    UCHAR right;
    UCHAR mode;
    UCHAR font[4];
} OFONT;

unsigned long LG(unsigned long l)
{
       union {
               unsigned long l;
               char c[4];
       } u,v;

       u.l = l;

       v.c[0] = u.c[3];
       v.c[1] = u.c[2];
       v.c[2] = u.c[1];
       v.c[3] = u.c[0];
       return v.l;
}

main(int ac, char **av)
{
   FILE *fp;
   OFONT *of;
   QFONT *qf;
   
   struct stat s;
   
   fp = fopen(av[1],"r+");
   fstat(fileno(fp), &s);
   printf("size %d\n", s.st_size);
   
   of = malloc(s.st_size);
   fread(of, s.st_size, 1, fp);
   printf("%d %d\n", of->xpix[0], of->xpix[1]);
   printf("%d %d\n", sizeof(QFONT), sizeof(OFONT));
   
   qf = malloc(s.st_size + sizeof(QFONT)- sizeof(OFONT));
   
   memcpy(qf->flag, of->flag, 8);
   qf->xpix = of->xpix[1];
   qf->ypix = of->ypix[1];
   qf->first = 0;
   qf->last = 255;
   qf->top_l = of->top_l;
   qf->bot_l = of->bot_l;
   qf->right = of->right;
   qf->mode = 0;
   qf->fsize = s.st_size - sizeof(OFONT) + 4;
   memcpy(qf->font, of->font, qf->fsize);
   qf->fsize = LG(qf->fsize);
   rewind(fp);
   fwrite(qf, s.st_size + sizeof(QFONT)- sizeof(OFONT), 1, fp);
   fclose(fp);
   return 0;
   
}
